<template>
  <div>
    <back></back>
    <!-- <pre>{{ getFieldConfig(['page', 'fields', 'hero', 'ref', 'hero_image', 'fields', 'bg_image', 'default', 0, 'field_media_image']) }}</pre> -->

    <h1 class="i3-page-title">{{ 'Edit ' + (getFieldConfig([keys(nodesList)[0]]).label || 'Node') }}</h1>

    <label>
      <input type="checkbox" v-model="originalNodes">Original nodes
    </label>
    <div v-if="originalNodes">
      <button @click="revert">Revert</button>
    </div>
    <div id="shortcut-area" v-if="showActiveZone">
      <h2>{{ activeTitle }}</h2>
      <div v-for="(activeField, index) in activeFields" :key="index">
        <!-- <pre>LOOO</pre>
        <pre>{{ activeField }}</pre>
        <pre>{{ getEditedNodes([activeField.type, activeField.key]) }}</pre> -->
        <items-types-form :node="getEditedNodes([activeField.type, activeField.key]) || {}" :path="activeField.path"></items-types-form>
        <!-- <item-form :label="(getFieldConfig(activeField) || {}).label + (Number.isInteger(activeField.path.slice(-1).pop()) ? ' #' + (activeField.path.slice(-1).pop() + 1) : '')" :node="activeField.node" :path="activeField.path" :config="getFieldConfig(activeField)" :index="Number.isInteger(activeField.path.slice(-1).pop()) ? activeField.path.slice(-1).pop() : -1"></item-form> -->
      </div>
    </div>

    <div v-for="(nodes, type) in nodesList" :key="type">
      <div v-for="(node, key) in nodes" :key="key">
        <button @click="saveNode(node)" v-if="!isOriginalNodesDisplayed">Save</button>
        <items-form :title="(getFieldConfig([type]).label || 'Node') + ' #' + (getEditedNodes([type, key]) || {}).nid" :node="getEditedNodes([type, key])" :path="[]" :config="getFieldConfig([type])"></items-form>
        <!-- <h4>{{ type }} #{{ node.nid }}</h4>
        <div v-for="(value, key) in node" :key="key" v-if="!excludeList.includes(key)">
          <label>
            {{ getFieldConfig([type, key, 'label']) }}
            <component :is="'text-field'" :node="node" :config="getFieldConfig([type, key])"></component>
          </label>
        </div> -->
      </div>
    </div>
    <!-- <pre>{{ getFieldConfig([type]) }}</pre> -->
    <!-- <pre>{{ currentFieldsConfig }}</pre> -->
  </div>
</template>

<script>
import _ from 'lodash'
// import { EDITABLE_FIELD_CONFIG } from '@/config'

import { mapGetters, mapActions } from 'vuex'

// import TextField from '@/components/Editable/Fields/Widgets/TextFieldWidgetField'
import ItemsForm from './ItemsForm'
import ItemsTypesForm from './ItemsTypesForm'
// import ItemForm from '@/components/Editable/EditorCategory/ItemForm'
import Back from '@/components/Editable/Utils/Back'

export default {
  components: {
    Back,
    // TextField,
    ItemsForm,
    // ItemForm,
    ItemsTypesForm
  },

  data () {
    return {
      // excludeList: ['_type', 'nid']
    }
  },

  computed: {
    ...mapGetters({
      getEditableNodes: 'Y3TI/getEditableNodes',
      getFieldConfig: 'Y3TI/getFieldConfig',
      getEditedNodes: 'Y3TI/getEditedNodes',
      showActiveZone: 'Y3TI/showActiveZone',
      activeFields: 'Y3TI/activeFields',
      activeTitle: 'Y3TI/activeTitle',
      isOriginalNodesDisplayed: 'Y3TI/isOriginalNodesDisplayed',
      backPageTitle: 'Y3TI/backPageTitle'
    }),

    nodesList () {
      return this.getEditableNodes(this.$route.path)
    },

    originalNodes: {
      get () {
        return this.isOriginalNodesDisplayed
      },
      set (value) {
        this.setOriginalNodesDisplay(value)
        // this.$store.commit('updateList', value)
      }
    }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    // },

    // textfieldData () {
    //   return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    // }
  },

  methods: {
    // getFieldsGroupConfig: EDITABLE_FIELDS_GROUP_CONFIG,
    // getFieldOptions: EDITABLE_FIELD_CONFIG,
    // fieldOptions (config, fieldConfig) {
    //   return this.getFieldOptions(config, fieldConfig)
    // },
    ...mapActions({
      saveEditedNodeData: 'Y3TI/saveEditedNodeData',
      setOriginalNodesDisplay: 'Y3TI/setOriginalNodesDisplay',
      unsetEditableActiveZone: 'Y3TI/unsetEditableActiveZone',
      revertAllToOriginalNodes: 'Y3TI/revertAllToOriginalNodes',
      backSidebarPage: 'Y3TI/backSidebarPage'
    }),

    saveNode (node) {
      this.saveEditedNodeData({ data: { action: 'editNode', node } })
    },

    revert () {
      if (window.confirm('Are you sure you want to discard all your changes?')) {
        this.revertAllToOriginalNodes()
      }
    },

    backPage () {
      this.unsetEditableActiveZone({ data: { id: '*' } })
      this.setOriginalNodesDisplay(false)
      this.backSidebarPage()
    },

    keys: _.keys
    // update (e) {
    //   this.storeEditableFieldData({ data: { path: this.editablePath, input: e.target.innerHTML } })
    // }
  }
}
</script>

<style lang="scss" scoped>
</style>
